/**
 * OnClick handlers are defined here
 * These functions will call functions in pdfannotate.js.
 *
 * @module     qtype_essayannotate/clickhandlers
 * @copyright  2024 IIT Palakkad
 * @copyright  based on work done by Ravisha Hesh {@link https://github.com/RavishaHesh/PDFJsAnnotations/tree/master}
 * @license    http://opensource.org/licenses/mit-license The MIT License
 * @author     Tausif Iqbal, Vishal Rao (IIT Palakkad)
 * @updatedby  Parvathy S Kumar, Asha Jose
 * @updatedby  Nideesh N, VM Sreeram
 *             Converted into AMD format, added event listeners for all the tools,
 *             removed unused onPageUpdated function, disabled save and exit button when clicked once
 */
define("qtype_essayannotate/clickhandlers",["jquery","qtype_essayannotate/pdfannotate"],(function($,PDFAnnotate){function changeActiveTool(event){event.preventDefault();var element=$(event.target).hasClass("tool-button")?$(event.target):$(event.target).parents(".tool-button").first();$(".tool-button.active").removeClass("active"),$(element).addClass("active")}return{init:function(fileurl){var pdf=new PDFAnnotate.PDFAnnotate("pdf-container",fileurl,{ready:function(){},scale:1.5,pageImageCompression:"SLOW"});"undefined"!=typeof window&&(window.pdf=pdf),$((function(){$(".color-tool").click((function(){$(".color-tool.active").removeClass("active"),$(this).addClass("active");var color=$(this).get(0).style.backgroundColor;pdf.setColor(color)})),$("#font-size").change((function(){var fontSize=$(this).val();pdf.setFontSize(fontSize)}))}));document.getElementById("pencil").addEventListener("click",(function(event){!function(event,pdf){event.preventDefault(),changeActiveTool(event),pdf.enablePencil()}(event,pdf)}));document.getElementById("select").addEventListener("click",(function(event){!function(event,pdf){event.preventDefault(),changeActiveTool(event),pdf.enableSelector()}(event,pdf)}));document.getElementById("text").addEventListener("click",(function(event){!function(event,pdf){event.preventDefault(),changeActiveTool(event),pdf.enableAddText()}(event,pdf)}));document.getElementById("rectangle").addEventListener("click",(function(event){!function(event,pdf){event.preventDefault(),changeActiveTool(event),pdf.enableRectangle()}(event,pdf)}));document.getElementById("deletebtn").addEventListener("click",(function(event){!function(event,pdf){event.preventDefault(),pdf.deleteSelectedObject()}(event,pdf)}));document.getElementById("savebtn").addEventListener("click",(function(event){!function(event,pdf){document.getElementById("savebtn").setAttribute("disabled","true"),event.preventDefault(),pdf.savePdf()}(event,pdf)}))}}}));

//# sourceMappingURL=clickhandlers.min.js.map